/***********************/
/* lacescheme.c 1.00   */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#include "lacescheme.h"  /* Also includes <stdio.h>. */

#include "adamfive.h"
#include "adamseven.h"
#include "giffive.h"
#include "giflace.h"
#include "leefive.h"
#include "leeseven.h"
#include "nolace.h"
#include "owenfive.h"
#include "refine.h"
#include "rowparity.h"
#include "scatter.h"
#include "sperse.h"
#include "wilhitethree.h"
#include "wilhitefour.h"

#include <string.h>


schemeimpl defaultscheme = nolace;


schemeimpl lacescheme(const char *opt)
{
  return !strcmp(opt, "-a5") ? adamfive :
         !strcmp(opt, "-a7") ? adamseven :
         !strcmp(opt, "-g5") ? giffive :
         !strcmp(opt, "-gi") ? giflace :
         !strcmp(opt, "-l5") ? leefive :
         !strcmp(opt, "-l7") ? leeseven :
         !strcmp(opt, "-nl") ? nolace :
         !strcmp(opt, "-o5") ? owenfive :
         !strcmp(opt, "-re") ? refine :
         !strcmp(opt, "-rp") ? rowparity :
         !strcmp(opt, "-sc") ? scatter :
         !strcmp(opt, "-sp") ? intersperse :
         !strcmp(opt, "-w3") ? wilhitethree :
         !strcmp(opt, "-w4") ? wilhitefour :
         NULL;
}


void laceopts(FILE *f)
{
  fputs("  -a5                      Use Adam's five-pass scheme\n"
        "  -a7                      Use Adam's seven-pass scheme\n"
        "  -g5                      Use the GIF5 interlace scheme\n"
        "  -gi                      Use the GIF interlace scheme\n"
        "  -l5                      Use Lee's five-pass scheme\n"
        "  -l7                      Use Lee-style seven-pass scheme\n"
        "  -nl                      Use no interlace scheme (default)\n"
        "  -o5                      Use Owen's five-pass scheme\n"
        "  -re                      Use the refine scheme\n"
        "  -rp                      Use the row parity scheme\n"
        "  -sc                      Use the scatter scheme\n"
        "  -sp                      Use the intersperse scheme\n"
        "  -w3                      Use Wilhite's three-pass scheme\n"
        "  -w4                      Use Wilhite's four-pass scheme\n"
        , f);
}
