/***********************/
/* lacescheme.h 1.00   */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#include <stdio.h>


typedef void (*schemeimpl)(int width, int height);

  /* A scheme implementation is a pointer to a function taking two    */
  /* integer parameters, the width and height of the image, and       */
  /* returning void.  The function should call visit(), see visit.h.  */


extern schemeimpl defaultscheme;

  /* The function that implements the default interlace scheme. */


schemeimpl lacescheme(const char *opt);

  /* lacescheme(opt) returns a pointer to a function that implements  */
  /* the interlace scheme corresponding to the command-line option    */
  /* opt.  Returns NULL if opt is unrecognized.                       */


void laceopts(FILE *f);

  /* Prints to f a list of interlace scheme */
  /* options with brief descriptions.       */
