/***********************/
/* refine.c 1.00       */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#include "refine.h"
#include "visit.h"


static int width, height;


static void dorefine(int row, int col, int step, int align, int scale)
{
  int nextrow, nextcol, nextstep, nextalign, onerow, onecol, lastrow, lastcol;

  nextrow = row + step;
  nextcol = col + step;
  nextstep = step << 1;
  nextalign = step < align ? step : align;
  onerow = row + step >= height;
  onecol = col + step >= width;

  if (onerow && onecol) {
    if (!scale) {
      visit(row,col,align,align);
    }
    else {
      lastrow = row + scale >= height;
      lastcol = col + scale >= width;
      if (!lastrow && !lastcol) visit(row + scale, col + scale, scale, scale);
      if (!lastcol) visit(row, col + scale, scale, scale);
      if (!lastrow) visit(row + scale, col, scale, scale);
    }
  }
  else {
    if (scale) {
      dorefine(row,col,nextstep,align,scale);
      if (!onerow && !onecol)
        dorefine(nextrow,nextcol,nextstep,nextalign,scale);
      if (!onecol) dorefine(row,nextcol,nextstep,nextalign,scale);
      if (!onerow) dorefine(nextrow,col,nextstep,nextalign,scale);
    }
    else {
      dorefine(row,col,nextstep,align,0);
      dorefine(row,col,nextstep,align,step);
    }
  }
}


void refine(int w, int h)
{
  int align;

  width = w;
  height = h;

  for (align = 1;  align < width || align < height;  align <<= 1);

  dorefine(0,0,1,align,0);
}
