/***********************/
/* scatter.c 1.00      */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#include "scatter.h"
#include "visit.h"


static int width, height;


typedef enum {square, tall, undetermined} pixshape;


static void doscatter(int row, int col, int step, int align, pixshape shape)
{
  int nextrow, nextcol, nextstep, nextalign, prefersquare, prefertall, w;

  nextrow = row + step;
  nextcol = col + step;
  nextstep = step << 1;
  nextalign = step < align ? step : align;

  if (shape == undetermined) {
    prefersquare = square;
    prefertall = tall;
  }
  else {
    prefersquare = shape;
    prefertall = shape;
  }

  w = shape == tall ? align << 1 : align;

  if (col + step >= width) {
    if (row + step >= height) visit(row,col,align,w);
    else {
      doscatter(row,col,nextstep,align,shape);
      doscatter(nextrow,col,nextstep,nextalign,prefersquare);
    }
  } else if (row + step >= height) {
    if (col + step >= width) visit(row,col,align,w);
    else {
      doscatter(row,col,nextstep,align,shape);
      doscatter(row,nextcol,nextstep,nextalign,prefersquare);
    }
  } else {
    doscatter(row,col,nextstep,align,shape);
    doscatter(nextrow,nextcol,nextstep,nextalign,prefertall);
    doscatter(row,nextcol,nextstep,nextalign,prefersquare);
    doscatter(nextrow,col,nextstep,nextalign,prefersquare);
  }
}


void scatter(int w, int h)
{
  int align;

  width = w;
  height = h;

  for (align = 1;  align < width || align < height;  align <<= 1);

  doscatter(0,0,1,align,undetermined);
}
