/***********************/
/* sperse.c 1.00       */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#include "sperse.h"
#include "visit.h"


void intersperse(int width, int height)
{
  int row, col, firststep, step, nextstep;

  for (firststep = 1;
       firststep < width || firststep < height;
       firststep <<= 1);

  visit(0,0,firststep,firststep);

  for (step = firststep;  step > 1;  step = nextstep) {
    nextstep = step / 2;
    for (row = nextstep;  row < height;  row += step)
      for (col = nextstep;  col < width;  col += step)
        visit(row,col,nextstep,step);
    for (row = 0;  row < height;  row += step)
      for (col = nextstep;  col < width;  col += step)
        visit(row,col,nextstep,nextstep);
    for (row = nextstep;  row < height;  row += step)
      for (col = 0;  col < width;  col += step)
        visit(row,col,nextstep,nextstep);
  }
}
