/***********************/
/* timer.c 1.01        */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C plus some variety of  */
/* UNIX code.  (It works on SunOS 5.3.) */


#include "timer.h"

#include <sys/time.h>
#include <unistd.h>
#include <signal.h>


static const int cutoff = 20;

static int tickspersignal = 0;


static void donothing(int sig) {
}


void settimer(freq) {
  struct itimerval itv;
  unsigned long usec;

  tickspersignal = freq <= cutoff ? 1 : (freq + cutoff - 1) / cutoff;
  usec = 1000000.0 / freq * tickspersignal;
  itv.it_interval.tv_sec = usec / 1000000;
  itv.it_interval.tv_usec = usec % 1000000;
  itv.it_value = itv.it_interval;

  sigset(SIGALRM,donothing);
  setitimer(ITIMER_REAL, &itv, NULL);
}


void waitfortick(void) {
  static int n = 0;

  if (++n >= tickspersignal) {
    n = 0;
    pause();
  }
}
