/***********************/
/* visit.h 1.00        */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#ifndef VISIT_H
#define VISIT_H


#include <stdio.h>


typedef struct IMAGE IMAGE;


IMAGE *loadimage(FILE *ppmfile, int width, int height);

  /* loadimage(ppmfile,width,height) reads the image data from      */
  /* ppmfile (a P6 file), returning an image pointer which can be   */
  /* passed to useimage() and freeimage().  The file pointer on     */
  /* ppmfile MUST be at the start of image data (after the header). */
  /* loadimage() Calls fail() if there is not enough memory.        */


void useimage(IMAGE *image);

  /* useimage(image) sets the current image.  This affects visit(). */


void freeimage(IMAGE *image);

  /* freeimage(image) frees the image.  After this call, image must */
  /* not be used.                                                   */


void visit(int row, int col, int w, int h);

  /* If the window implementation is used, then visit(row,col,w,h)    */
  /* draws a rectangle of width w and height h with its upper left    */
  /* corner at the given row and column, using the color from the     */
  /* pixel at the same location in the current image, set by the      */
  /* last call to useimage().  If the file implementation is used,    */
  /* visit(row,col,w,h) writes the 8-bit RGB values at (row,col) to   */
  /* stdout.                                                          */


#endif /* VISIT_H */
