/***********************/
/* visitcommon.c 1.00  */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C code. */


#include "visit.h"   /* Also includes stdio.h. */
#include "fail.h"

#include <stdlib.h>


struct IMAGE {
  unsigned char **red, **green, **blue;
};

static struct IMAGE *current;


IMAGE *loadimage(FILE *ppmfile, int width, int height)
{
  IMAGE *image;
  int row, col;
  unsigned char **red, **green, **blue;

  image = malloc(sizeof (IMAGE));
  if (!image) fail(outofmem);

  image->red   = malloc(height * sizeof (unsigned char *));
  image->green = malloc(height * sizeof (unsigned char *));
  image->blue  = malloc(height * sizeof (unsigned char *));
  if (!image->red || !image->green || !image->blue) fail(outofmem);

  red   = image->red;
  green = image->green;
  blue  = image->blue;

  red[0]   = malloc(height * width * sizeof (unsigned char));
  green[0] = malloc(height * width * sizeof (unsigned char));
  blue[0]  = malloc(height * width * sizeof (unsigned char));
  if (!red[0] || !green[0] || !blue[0]) fail(outofmem);

  for (row = 1;  row < height;  ++row) {
    red[row]   = red[0]   + row * width;
    green[row] = green[0] + row * width;
    blue[row]  = blue[0]  + row * width;
  }

  for (row = 0;  row < height;  ++row)
    for (col = 0;  col < width;  ++col) {
      red[row][col]   = fgetc(ppmfile);
      green[row][col] = fgetc(ppmfile);
      blue[row][col]  = fgetc(ppmfile);
    }

  return image;
}


void useimage(IMAGE *image) {
  current = image;
}


void freeimage(IMAGE *image) {
  free(image->red[0]);
  free(image->green[0]);
  free(image->blue[0]);
  free(image->red);
  free(image->green);
  free(image->blue);
  free(image);
}
