/***********************/
/* window.h 1.00       */
/* for TestLace        */
/* by Adam M. Costello */
/* (amc@cs.wustl.edu)  */
/***********************/

/* This is ANSI C plus X11R5 code. */


#ifndef WINDOW_H
#define WINDOW_H


#include <X11/Xlib.h>


void initwindow(const char *name, int width, int height);

  /* initwindow(name,width,height) creates a window with the   */
  /* specified name, width, and height.  The dimensions of the */
  /* workspace sub-window are width by height.  initwindow()   */
  /* waits for the initial expose event.  This function must   */
  /* be called before anything else declared in this header    */
  /* file is used, except display, which must be set before    */
  /* initwindow() is called.                                   */


void drawrect(int x, int y, int w, int h, unsigned short red,
                unsigned short green, unsigned short blue);

  /* drawsquare(x,y,w,h,red,green,blue) draws a rectange of width w */
  /* and height h, whose upper left corner is at (x,y) in X window  */
  /* coordinates, using the indicated RGB color.                    */


extern Display *display;

  /* display is global for convenience.  It should be set by whomever */
  /* opens the display.                                               */


#endif
